﻿Public Delegate Sub TrickAction()

Public MustInherit Class CircusAnimal
#Region " Properties "
    Private _Legs As Integer
    Public Property Legs() As Integer
        Get
            Return _Legs
        End Get
        Set(ByVal value As Integer)
            _Legs = value
        End Set
    End Property

    Private _LegsOnGround As Integer
    Public Property LegsOnGround() As Integer
        Get
            Return _LegsOnGround
        End Get
        Set(ByVal value As Integer)
            _LegsOnGround = value
        End Set
    End Property

    Private _TricksDone As Integer
    Public Property TricksDone() As Integer
        Get
            Return _TricksDone
        End Get
        Set(ByVal value As Integer)
            _TricksDone = value
        End Set
    End Property

    Private _IncentivesGiven As Integer
    Public Property IncentivesGiven() As Integer
        Get
            Return _IncentivesGiven
        End Get
        Set(ByVal value As Integer)
            _IncentivesGiven = value
        End Set
    End Property
    Protected Sound As String
#End Region

#Region " Delegates "
    Public Sub Speak()
        Console.WriteLine(Sound)
        TricksDone += 1
    End Sub

    Public Shared Sub WatchOthers()
        Console.WriteLine("Watching is boring")
    End Sub

    Public Sub Stand()
        If LegsOnGround = 4 Then
            LegsOnGround -= 2
        End If
        Console.WriteLine("Legs on Ground = {0}", LegsOnGround)
    End Sub

    Public Sub DoTrick(ByVal trick As TrickAction)
        If TricksDone <= IncentivesGiven Then
            trick.Invoke()
        Else
            Console.WriteLine("Need an incentive")
        End If
        RaiseEvent RequestIncentive(Me, Nothing)
    End Sub

    Public Sub DoTrick(ByVal trick As TrickAction, ByVal incentivesGiven As Integer)
        Me.IncentivesGiven += incentivesGiven
        DoTrick(trick)
    End Sub

    Public Event RequestIncentive(ByVal sender As CircusAnimal, ByVal e As EventArgs)

    Public TrickList As New List(Of TrickAction)
    Public Sub DoTricks()
        For Each trick In TrickList
            trick.Invoke()
        Next
    End Sub
#End Region

#Region " Business Rules "
    Private ValidationRules As New List(Of Predicate(Of CircusAnimal))
    Public Function IsValid()
        Return ValidationRules.Where(Function(rule) rule.Invoke(Me)).FirstOrDefault Is Nothing
    End Function
#End Region
End Class
