﻿Module Module1

     Sub Main()
        DoDelegateSamples()
        DoTrickList()
        Console.ReadLine()
    End Sub

    Private Function GetAnimals() As List(Of CircusAnimal)
        Dim animals As New List(Of CircusAnimal)
        animals.Add(New Lion)
        animals.Add(New Tiger)
        animals.Add(New Bear)
        Return animals
    End Function

    Private Sub DoDelegateSamples()
        Dim animals As List(Of CircusAnimal) = GetAnimals()
        For Each animal In animals
            Console.WriteLine(animal.GetType.Name)
            AddHandler animal.RequestIncentive, AddressOf GiveIncentive

            'Instance delegate
            animal.DoTrick(AddressOf animal.Stand)

            'Shared delegate
            animal.DoTrick(AddressOf CircusAnimal.WatchOthers)

            'Overloaded method
            animal.DoTrick(AddressOf animal.Speak, 2)

            'Named delegate
            animal.DoTrick(AddressOf delegateaction)

            'Statement lambdas not available in VB 9
            'See http://www.panopticoncentral.net/archive/2008/07/29/24100.aspx
            'animal.DoTrick(Sub() Console.WriteLine("Anonymous Method"))

        Next

        Console.WriteLine()
    End Sub

    Private Sub DoTrickList()
        Dim animals As List(Of CircusAnimal) = GetAnimalsWithTrickList
        For Each animal In animals
            Console.WriteLine(animal.GetType.Name)
            animal.DoTricks()
            Console.WriteLine("Legs now on ground: {0}", animal.LegsOnGround)
            Console.WriteLine("Animal valid: {0}", animal.IsValid)
            Console.WriteLine()
        Next

        'Find invalid anumals
        Console.WriteLine("Invalid: ")
        For Each animal In animals.Where(Function(item) Not item.IsValid)
            Console.WriteLine(animal.ToString)
        Next
    End Sub

    Private Sub DelegateAction()
        Console.WriteLine("Performing an action as a named delegate")
    End Sub

    Private Sub GiveIncentive(ByVal sender As Object, ByVal e As EventArgs)
        DirectCast(sender, CircusAnimal).IncentivesGiven += 1
    End Sub

    Private Function GetAnimalsWithTrickList() As List(Of CircusAnimal)
        Dim animals = GetAnimals()
        animals(0).TrickList.Add(AddressOf animals(0).Stand)
        animals(1).TrickList.Add(AddressOf CircusAnimal.WatchOthers)
        animals(2).TrickList.Add(AddressOf animals(2).Speak)
        animals(0).TrickList.Add(AddressOf DelegateAction)
        Return animals
    End Function

   
End Module
